
import 'dart:async';

import 'package:flutter/material.dart';

class BoomStarButton extends StatefulWidget {





  const BoomStarButton({Key? key,}) : super(key: key);

  @override
  _BoomStarButtonState createState() => _BoomStarButtonState();
}

class _BoomStarButtonState extends State<BoomStarButton> with TickerProviderStateMixin{
  bool isClick = false;


  late Timer _timer;
  int _start = 4;

  void startTimer() {
    const oneSec = Duration(seconds: 1);
    _timer =  Timer.periodic(
      oneSec,
          (Timer timer) {
        if (_start == 0) {
          setState(() {
            timer.cancel();
            isClick=false;
          });
        } else {
          setState(() {
            _start--;
          });
        }
      },
    );
  }
  @override
  void dispose() {
    super.dispose();
    _timer.cancel();
  }
  @override
  Widget build(BuildContext context) {
    return Material(
        child: Center(
          // Center is a layout widget. It takes a single child and positions it
          // in the middle of the parent.
            child: GestureDetector(
              onTap: (){
                setState(() {
                  isClick =true;
                  startTimer();
                });
              },
              child: Stack(
                children: [

                  Positioned(
                    left: 0,
                    right: 0,
                    bottom: 0,
                    top: 0,
                    child: IconButton(
                      onPressed: (){

                      },
                      icon: const Icon(Icons.star,color: Colors.amber,size: 100,),
                    ),
                  ),
                  AnimatedPositioned(
                      bottom: isClick ?-170.0:0.0,
                      left: isClick ? 100 :0,
                      right: 0,

                      top: 0,
                      child: const Icon(Icons.star,color: Colors.amber,size: 60,), duration: const Duration(milliseconds: 500)),
                  AnimatedPositioned(
                      bottom: isClick ?-170.0:0.0,
                      left: 0,
                      right: isClick?100:0,

                      top: 0,
                      child: const Icon(Icons.star,color: Colors.amber,size: 60,), duration:const Duration(milliseconds: 500)),
                  AnimatedPositioned(
                      bottom:  0.0,
                      left: isClick ? 170:0,
                      right: 0,

                      top: 0,
                      child: const Icon(Icons.star,color: Colors.amber,size: 60,), duration:const Duration(milliseconds: 500)),
                  AnimatedPositioned(
                      bottom:  0.0,
                      left: 0,
                      right:isClick?170: 0,

                      top: 0,
                      child: const Icon(Icons.star,color: Colors.amber,size: 60,), duration:const Duration(milliseconds: 500)),
                  AnimatedPositioned(
                      bottom:0.0,
                      left: 0,
                      right: 0,

                      top: isClick?-170:0,
                      child: const Icon(Icons.star,color: Colors.amber,size: 60,), duration:const Duration(milliseconds: 500)),
                ],
              ),
            )
        ));
  }
}
